SET FOREIGN_KEY_CHECKS=0;

CREATE TABLE `el_pm_dialogs` (
`id` mediumint unsigned NOT NULL auto_increment,
`owner` mediumint unsigned NOT NULL,
`from` mediumint unsigned NOT NULL,
`lastview` timestamp NOT NULL default '0000-00-00 00:00:00',
`sent` tinyint NOT NULL,
`tid` mediumint unsigned NOT NULL,
`lp_date` timestamp NOT NULL default '0000-00-00 00:00:00',
`caninvate` tinyint NOT NULL,
`canpermit` tinyint NOT NULL,
`status` tinyint unsigned NOT NULL,
`invated` tinyint unsigned NOT NULL,
PRIMARY KEY  (`id`),
KEY `os` (`owner`,`status`,`lp_date`),
KEY `sent` (`tid`,`sent`),
KEY `ot` (`owner`,`tid`),
FOREIGN KEY (`owner`) REFERENCES `el_users_site` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=cp1251;

CREATE TABLE `el_pm_groups` (
`id` smallint unsigned NOT NULL,
`on` tinyint NOT NULL default '1',
`maxdialogs` smallint unsigned NOT NULL,
`maxinvates` tinyint unsigned NOT NULL,
`editlimit` smallint unsigned NOT NULL,
PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=cp1251;

CREATE TABLE `el_pm_posts` (
`id` mediumint unsigned NOT NULL auto_increment,
`date` timestamp NOT NULL default '0000-00-00 00:00:00',
`tid` mediumint unsigned NOT NULL,
`author` varchar(25) NOT NULL,
`author_id` mediumint unsigned NOT NULL,
`hasattach` tinyint NOT NULL,
`text` text NOT NULL,
PRIMARY KEY  (`id`),
KEY `showtopic` (`tid`,`date`),
FOREIGN KEY (`author_id`) REFERENCES `el_users_site` (`id`) ON DELETE NO ACTION ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=cp1251;

CREATE TABLE `el_pm_topics` (
`id` mediumint unsigned NOT NULL auto_increment,
`posts` smallint unsigned NOT NULL default '1',
`title` tinytext NOT NULL,
`date` timestamp NOT NULL default '0000-00-00 00:00:00',
`lp_id` mediumint unsigned NOT NULL,
`lp_author` varchar(25) NOT NULL,
`lp_author_id` mediumint UNSIGNED NOT NULL,
`lp_date` timestamp NOT NULL default '0000-00-00 00:00:00',
`hasattach` tinyint NOT NULL,
`last_mod` timestamp NOT NULL default '0000-00-00 00:00:00',
PRIMARY KEY (`id`),
KEY `lp_date` (`lp_date`),
KEY `lp_author_id` (`lp_author_id`),
FOREIGN KEY (`lp_author_id`) REFERENCES `el_users_site` (`id`) ON DELETE NO ACTION ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=cp1251;