﻿/*
	Copyright © Alexander Sunvas
	ICQ: 122255566, 854984
	URL: http://eleanor.su, http://eleanor-cms.ru, http://eleanor-cms.su
	E-mail: a@eleanor-cms.ru; sunvas@vingrad.ru
	=======================================
	Powered by Sunvas. Resale is forbidden!
*/

CORE.PM={
	module:"pm",
	lastpage:false,
	editor:false,
	noupdate:false,

	SimpleRecepients:function(field,max)
	{
		$(field).autocomplete({
			serviceUrl:CORE.ajax_file,
			minChars:2,
			delimiter:/,\s*/,
			maxvalues:max,
			params:{
				module:CORE.PM.module,
				event:"completeuser"
			}
		});
	},

	ComplexRecepients:function(field,max)
	{
		var ul=$(field),
			NumTrs=function()
			{
				return ul.find("li").size();
			},
			ACScan=function()
			{
				ul.find("input.namehere").each(function(){
					var li=$(this).closest("li");
					$(this).autocomplete({
						serviceUrl:CORE.ajax_file,
						minChars:2,
						delimiter:null,
						onSelect:function(value,data){
							li.find("[name^=\"caninvate\"],[name^=\"canpermit\"],[name^=\"_to\"]").prop("name",function(ind,old){
								return old.replace(/\[\d*\]$/,"["+data+"]");
							})
						},
						params:{
							module:CORE.PM.module,
							event:"completeuser"
						}
					});
				});
			}

			ul.on("click",".plus",function(){
				if(max==0 || NumTrs()<max)
				{
					var li=$(this).closest("li");
					li.clone(false)
						.find("input").val("").prop("checked",false)
						.prop("name",function(ind,old){
							return old.replace(/\[\d*\]$/,"[]");
						}).end()
					.insertAfter(li);
					ACScan();
				}
				return false;
			}).on("click",".minus",function(){
				var li=$(this).closest("li");
				if(NumTrs()>1)
					li.remove();
				else
					li.find("input[type=\"text\"]").val("").end().find(":checkbox").prop("checked",false);
				return false;
			})
			ACScan();
	},

	ChangeRecepients:function(obj,form,invate)
	{
		CORE.Ajax(
			{
				module:this.module,
				language:CORE.lang_name,
				event:"change-recepients",
				data:CORE.Inputs2object($(":input",form)),
				invate:invate||0
			},
			function(r)
			{
				$(form).html(r.html);
				$(obj).html(CORE.Lang(r.simple ? "m_pm_showo" : "m_pm_hideo"));
			}
		)
	},

	DeleteDialog:function(id,F)
	{
		CORE.Ajax(
			{
				module:this.module,
				language:CORE.lang_name,
				event:"dd",
				ids:id
			},
			F
		)
	},

	ArchiveDialog:function(id,F)
	{
		CORE.Ajax(
			{
				module:this.module,
				language:CORE.lang_name,
				event:"ad",
				ids:id
			},
			F
		)
	},

	ToInbox:function(id,F)
	{
		CORE.Ajax(
			{
				module:this.module,
				language:CORE.lang_name,
				event:"ti",
				ids:id
			},
			F
		)
	},

	InvateUsers:function(did)
	{
		CORE.Ajax(
			{
				module:this.module,
				language:CORE.lang_name,
				event:"invate",
				data:CORE.Inputs2object($(":input","#invate")),
				id:did
			},
			function(r)
			{
				$("#invate").hide().find(":input").filter(":visible").not("[type=button]").val("");
				$("#invate_img,#invate .minus").click();
				$("#takepart").html(r);
			},
			function(r)
			{
				alert(r.error);
				if(r.captcha)
					$("#invate_img").click();
			}
		);
	}
}

$(function(){
	var EditLimitDrop=function()
	{
		var th=$(this);
		if(!th.data("el"))
			return;
		setTimeout(function(){
			th.remove();
		},th.data("el")*1000);
	},
	NewHash=function(h)
	{
		with(window.location)
		{
			if(hash.replace(/#/g,"")==h)
				hash="";
			hash=h;
		}
	},

	//Загрузка новых постов
	to,
	Finish=function(tl)
	{
		clearTimeout(to);
		to=setTimeout(function(){
			$("#pm .status").fadeOut("slow",function(){
				$(this).removeClass("load ok error");
			});
		},tl||3000);
	},
	LoadNewPosts=function(r)
	{
		if(r)
		{
			CORE.PM.n=r.n;
			CORE.PM.lp=r.lp;
			CORE.PM.lastpage=true;
			$("#pm .posts").append(r.posts);
			NewHash("#post"+r.first);
		}
		$("#pm .status").show().removeClass("load error").addClass("ok").text(CORE.Lang(r ? "m_pm_pl" : "m_pm_np"));
		Finish();
	};

	//Удаление диалога со списка
	$("#pm").on("click",".ddel",function(){
		var tr=$(this).closest("tr");
		if(confirm(CORE.Lang("m_pm_dd")))
			CORE.PM.DeleteDialog($(this).data("id"),function(){
				var table=tr.closest("table");
				tr.remove();
				if(table.find("tr").size()==2)
					table.find(".empty").show();
			});
		return false;
	})

	//Удаление диалога со страницы
	.on("click",".dvdel",function(){
		var th=$(this);
		if(confirm(CORE.Lang("m_pm_dd")))
			CORE.PM.DeleteDialog($(this).data("id"),function(){
				with(window.location)
				{
					href=protocol+"//"+hostname+(port ? ":"+port : "")+CORE.site_path+th.data("out");
				}
			});
		return false;
	})

	//Архивация диалога по страницы
	.on("click",".dvarch",function(){
		var th=$(this);
			CORE.PM.ArchiveDialog($(this).data("id"),function(){
				th.remove();
			});
		return false;
	})

	.on("click",".pm-ltp",function(){
		prompt(CORE.Lang("m_pm_copyl"),$(this).prop("href"));
		return false;
	})

	.on("click",".pm-insert-nick",function(){
		EDITOR.Insert("[b]"+$(this).text()+"[/b], ");
		return false;
	})

	.on("click",".pm-quick-quote",function(){
		var o=$(this),
			name=o.data("name"),
			text=o.closest(".post").find(".text:first").html(),
			sel,m;

		if(!o.data("date") || !name)
			return true;

		if(window.getSelection)
			sel=window.getSelection().toString();
		else if(document.getSelection)
			sel=document.getSelection().toString();
		else if(document.selection)
			sel=document.selection.createRange().text;
		if(!sel)
			return false;

		while(m=text.match(/<img[^>]+>/))
			text=text.replace(m[0],m[0].indexOf("alt=")==-1 || CORE.browser.opera || CORE.browser.ie ? "" : m[0].match(/alt="([^"]+)"/)[1]);

		text=text.replace(/<[^>]+>/g,"");
		//Это аналог функции html_entity_decode :)
		text=$("<textarea>").html(text).val();
		sele=sel;
 		while(sele.match(/(\r|\n|\s){2,}/))
	 		sele=sele.replace(/(\r|\n|\s)+/g," ");
 		while(text.match(/(\r|\n|\s){2,}/))
	 		text=text.replace(/(\r|\n|\s)+/g," ");

		if(text.indexOf(sele)!=-1)
			EDITOR.Insert("[quote name=\""+name+"\" date=\""+o.data("date")+"\"]\r\n"+sel+"\r\n[/quote]\r\n");
		else
			alert(CORE.Lang("m_pm_udnwt",[name]));
		return false;
	})

	.on("click",".pm-quick-edit",function(){
		var th=$(this);
		CORE.QAjax(
			{
				module:CORE.PM.module,
				language:CORE.lang_name,
				event:"edit",
				id:th.data("id")
			},
			function(r)
			{
				var tofull=false,
					post=th.closest(".post");
				post.find("form").remove().end().find(".text,.signature,.buttons,.files,.images").hide().end().find(".text:first").after(r).end()
				.find("form").submit(function(){
					if(tofull)
						return true;

					var params=CORE.Inputs2object($(this));

					if(params["text"+th.data("id")].length<5)
					{
						alert(CORE.Lang("m_pm_mintext"));
						return false;
					}

					CORE.Ajax(
						{
							module:CORE.PM.module,
							language:CORE.lang_name,
							event:"save",
							id:th.data("id"),
							data:params
						},
						function(rs)
						{
							post.find("form").remove();
							$.each(rs,function(k,v){
								var r=post.find("."+k);
								if(r.size()>0)
									r.replaceWith(v);
								else
									post.find(".text").after(v);
							});
							post.find(".text,.signature,.buttons,.files,.images").filter(":empty").remove().end().show();
							EDITOR.Active("text");
						}
					);
					return false;
				}).end()
				.on("click",".pm-cancel",function(){
					th.closest(".post").find("form").remove().end().find(".text,.signature,.buttons,.files,.images").filter(":empty").remove().end().show();
					EDITOR.Active("text");
					return false;
				})
				.on("click",".pm-to-full",function(){
					tofull=true;
				});
			}
		);
		return false;
	})

	.on("click",".pm-lnp",function(){
		CORE.Ajax(
			{
				module:CORE.PM.module,
				language:CORE.lang_name,
				event:"lnp",
				id:$(this).data("id"),
				lp:CORE.PM.lp,
				n:CORE.PM.n
			},
			{
				OnBegin:function()
				{
					clearTimeout(to);
					$("#pm .status").removeClass("ok error").addClass("load").text(CORE.Lang("m_pm_ploading")).show();
				},
				OnSuccess:LoadNewPosts,
				OnFail:function(s)
				{
					$("#pm .status").removeClass("load ok").addClass("error").text(s);
					Finish(5000);
				}
			}
		);
		return false;
	})

	.find(".pm-edit").each(EditLimitDrop);

	//Массовое удаление или архивация
	$("#pm-folder-form").submit(function(){
		var sel=$("select[name=op]",this),
			ev=sel.val();
		if(CheckGroup(this) && (ev=="ad" || confirm(CORE.Lang("m_pm_aus"))))
		{
			var ids=[],
				$ids=$("[name=\"mass[]\"]:checked",this).each(function(){
					ids.push($(this).val());
				});
			if(ids.length>0)
				CORE.Ajax(
					{
						module:CORE.PM.module,
						language:CORE.lang_name,
						event:ev,
						ids:ids
					},
					function()
					{
						if(sel.data("del"))
							$ids.closest("tr").remove();
						if($("#pm-folder-form table tr").size()==2)
							$("#pm-folder-form .empty").show();
					});
		}
		return false;
	});

	$("#pm-newpost").submit(function(){
		var text=$.trim(EDITOR.Get("text"));
		if(text.length<5)
		{
			alert(CORE.Lang("m_pm_emptytext"));
			return false;
		}
		CORE.Ajax(
			{
				module:CORE.PM.module,
				language:CORE.lang_name,
				event:"post",
				text:text,
				data:CORE.Inputs2object($(":input",this).not("[name=text]")),
				id:$(this).data("id"),
				redirect:CORE.PM.lastpage ? 0 : 1,
				lp:CORE.PM.lp,
				n:CORE.PM.n
			},
			{
				OnBegin:function()
				{
					clearTimeout(to);
					$("#pm .status").removeClass("ok error").addClass("load").text(CORE.Lang("m_pm_posting")).show();
				},
				OnSuccess:function(r)
				{
					if(typeof r=="string")
						with(window.location)
						{
							href=protocol+"//"+hostname+(port ? ":"+port : "")+CORE.site_path+r;
						}
					else
					{
						LoadNewPosts(r);
						$("#captcha_img").click();
						EDITOR.Set("",CORE.PM.editor);
						try{FI.Update()}catch(e){}
					}
				},
				OnFail:function(s)
				{
					$("#pm .status").removeClass("load ok").addClass("error").text(s);
					Finish(3000);
				}
			}
		);
		return false;
	});
})