<?php
/*
	Copyright © Alexander Sunvas
	ICQ: 122255566, 854984
	URL: http://eleanor.su, http://eleanor-cms.ru, http://eleanor-cms.su
	E-mail: a@eleanor-cms.ru; sunvas@vingrad.ru
	=======================================
	Powered by Sunvas. Resale is forbidden!
*/

class TPLUserPm
{
	/*
		Меню модуля
	*/
	public static function PmUserHeader($jsadd=array())
	{
		array_push($GLOBALS['jscripts'],'js/module_pm.js','js/module_pm-'.Eleanor::$Language.'.js');
		$lang=Eleanor::$Language[$GLOBALS['Eleanor']->module['config']['n']];
		$links=$GLOBALS['Eleanor']->module['links'];
		$GLOBALS['head'][__class__]=Eleanor::JsVars(array('module'=>$GLOBALS['Eleanor']->module['name'])+$jsadd,true,false,'CORE.PM.');

		return Eleanor::$Template->Menu(array(
			'menu'=>array(
				array($links['main'],$lang['inbox']),
				array($links['sent'],$lang['sent']),
				array($links['all'],$lang['allbox']),
				$links['new'] ? array($links['new'],$lang['newpm']) : false,
			),
			'title'=>end($GLOBALS['title']),
		));
	}

	/*
		Страница личных сообщений, отображаемая для гостей
	*/
	public static function PmNotUser()
	{
		$ma=array_keys($GLOBALS['Eleanor']->modules['sections'],'account');
		$ma=reset($ma);
		return Eleanor::$Template->Message(sprintf(Eleanor::$Language[$GLOBALS['Eleanor']->module['config']['n']]['notuser'],$GLOBALS['Eleanor']->Url->special.$GLOBALS['Eleanor']->Url->Construct(array('module'=>$ma,'do'=>'login'),false,''),$GLOBALS['Eleanor']->Url->special.$GLOBALS['Eleanor']->Url->Construct(array('module'=>$ma,'do'=>'register'),false,'')),'warning');
	}

	/*
		Страница личных сообщений для пользователя, чей почтовый ящик полон
	*/
	public static function PmMailboxFull()
	{
		return self::PmUserHeader()->Message(Eleanor::$Language[$GLOBALS['Eleanor']->module['config']['n']]['mailboxfull'],'error');
	}

	/*
		Страница создания личного сообщения/правка поста
		$id - идентификатор поста, который правится. Если равно 0, значит диалог создается
		$values - массив значений, ключи:
			text - текст сообщения

			только при создании:
			title - название диалога
			_opts - флаг отдельных опций для каждого получателя
			_to - строка либо массив (при включенном _opts) имен пользователей, кому направляются диалоги
			canpermit - флаг либо массив флагов (при включенном _opts) возможности включения разрешения приглашать пользователей к диалогу
			caninvate - флаг либо массив флагов (при включенном _opts) возможности приглашать пользователей к диалогу
		$uploader - загрузчик файлов
		$captcha - капча
		$errros - массив ошибок
		$bypost - признак того, что данные нужно брать из POST запроса
	*/
	public static function PmAddEdit($id,$values,$uploader,$captcha,$errors,$bypost)
	{
		$lang=Eleanor::$Language[$GLOBALS['Eleanor']->module['config']['n']];
		array_push($GLOBALS['jscripts'],'js/jquery.drag.js','addons/autocomplete/jquery.autocomplete.js');
		$GLOBALS['head'][__class__.__function__]='<link rel="stylesheet" type="text/css" href="addons/autocomplete/style.css" />';

		$C=self::PmUserHeader();
		if($errors)
		{
			foreach($errors as $k=>&$v)
				if(is_int($k) and isset($lang[$v]))
					$v=$lang[$v];
			$C->Message($errors,'error');
		}

		$Lst=Eleanor::LoadListTemplate('table-form')->form()->begin();

		if(!$id)
			$Lst->item(array($lang['towho'],'<div id="pmto">'.self::PmRecepient($values).'</div><div class="small"><a href="#" onclick="CORE.PM.ChangeRecepients(this,\'#pmto\');return false;">'.($values['_opts'] ? $lang['hideo'] : $lang['showo']).'</a></div>','td2'=>array('style'=>'width:80%')))
				->item($lang['subject'],Eleanor::Input('title',$values['title'],array('placeholder'=>$lang['*subject'],'tabindex'=>2,'style'=>'width: 300px;','id'=>'pm_title','size'=>30,'maxlength'=>100)));

		$Lst->item($lang['text'],$GLOBALS['Eleanor']->Editor->Area('text',$values['text'],array('bypost'=>$bypost,'bb'=>array('rows'=>10,'tabindex'=>3))));

		if($captcha)
			$Lst->item(array($lang['captcha'],$captcha.'<br />'.Eleanor::Input('check','',array('tabindex'=>4)),'descr'=>$lang['captcha_']));

		return'<div id="pm">'
			.$C
			.$Lst->end()
			->submitline((string)$uploader)
			->submitline(Eleanor::Button($id ? $lang['save'] : $lang['send'],'submit',array('tabindex'=>5)))
			->endform()
			.'</div>';
	}

	/*
		Страница отображения диалогов
		$dialogs - массив диалогов, формат id=>array(), ключи внутреннего массива:
			from - id отправителя
			lp_date - дата последнего сообщения
			status - статус
			posts - количество постов
			title - название
			lp_id - id последнего поста
			lp_author - имя автора последнего поста
			lp_author_id - id автора последнего поста
			hasattach - флаг наличия вложений в диалоге
			_a - ссылка на просмотр диалога
		$page - станица на которой мы находимся
		$cnt - количество диалогов всего
		$pp - количество тегов на страницу
		$sd - признак того, какие диалоги показываются: s - отправленные, a - все
		$qs - массив параметров адресной строки для каждого запроса
		$links - массив ссылок
			first_page - ссылка на первую страницу пагинатора
			pages - функция-генератор ссылок на остальные страницы
	*/
	public static function ShowDialogs($dialogs,$page,$cnt,$pp,$sd,$qs,$links)
	{
		$lang=Eleanor::$Language[$GLOBALS['Eleanor']->module['config']['n']];
		$GLOBALS['jscripts'][]='js/checkboxes.js';
		$Lst=Eleanor::LoadListTemplate('table-list',4)
			->begin(
				$lang['dialogt'],
				array($lang['lpd'],'style'=>'width:130px'),
				array($lang['posts'],'style'=>'width:40px'),
				array(Eleanor::Check('mass',false,array('id'=>'mass-check')),20)
			);

		$sent=$toinbox=$toarch=false;
		foreach($dialogs as $k=>&$v)
		{
			$v['status']=(int)$v['status'];
			$toinbox|=$v['status']&2;
			$sent|=$v['status']&4;
			$toarch|=~$v['status']>>1&1;
			$Lst->item(
				'<a href="'.$v['_a'].'">'.($v['hasattach'] ? ' <img src="images/pm/attach.png" alt="" />' : '').($v['status']&1 ? '<b>'.$v['title'].'</b>' : $v['title']).'</a>'.($v['status']&4 ? '&rarr;' : '').'<a style="float:right" href="#" data-id="'.$k.'" class="ddel" title="'.$lang['del'].'"><img src="templates/Audora/images/delete.png" /></a>',
				array(Eleanor::$Language->Date($v['lp_date'],'fdt').'<br /><a href="'.Eleanor::$Login->UserLink(htmlspecialchars_decode($v['lp_author'],ELENT),$v['lp_author_id']).'">'.$v['lp_author'].'</a>','center'),
				array((isset($v['_news']) ? '<b title="'.$lang['lnews'].'">'.$v['_news'].'</b> / ' : '').$v['posts'],'right'),
				Eleanor::Check('mass[]',false,array('value'=>$k))
			);
		}

		$C=self::PmUserHeader();
		if(!$GLOBALS['Eleanor']->module['can_new_pm'])
			$C->Message($lang['mailboxfull'],'error');
		elseif($GLOBALS['Eleanor']->module['maxdialogs']>0)
		{
			$pr=round($GLOBALS['Eleanor']->module['totald']/$GLOBALS['Eleanor']->module['maxdialogs']*100);
			$C->Message($lang['fullpr']($pr,$GLOBALS['Eleanor']->module['totald'],$GLOBALS['Eleanor']->module['maxdialogs']).'<br /><progress style="width:100%" value="'.$GLOBALS['Eleanor']->module['totald'].'" max="'.$GLOBALS['Eleanor']->module['maxdialogs'].'">'.$pr.'%</progress>','info');
		}

		return$C
			.'<div id="pm"><form method="post">'.Eleanor::Input('fi[search]',isset($qs['']['fi']['search']) ? (string)$qs['']['fi']['search'] : '',array('placeholder'=>'Найти')).' '.Eleanor::Button('Ok').'</form><form id="pm-folder-form" method="post">'
			.$Lst->empty($lang['dnf'])->end()
			.'<div class="submitline" style="text-align:right">'.sprintf($lang['withsel'],Eleanor::Select('op',($toarch ? Eleanor::Option($lang['archive'],'ad') : '').($toinbox ? Eleanor::Option($lang['toinout'],'tio') : '').Eleanor::Option($lang['del'],'dd'),array('data-del'=>$sd=='a' ? false : 1))).Eleanor::Button('Ok').'</div></form><script type="text/javascript">/*<![CDATA[*/$(function(){One2AllCheckboxes("#pm-folder-form","#mass-check","[name=\"mass[]\"]",true);'.($dialogs ? '$("#pm-folder-form .empty").hide()' : '').'})//]]></script>'
			.Eleanor::$Template->Pages($cnt,$pp,$page,array($links['pages'],$links['first_page']))
			.'</div>';
	}

	/*
		Оформление цитаты в при просмотре диалога
		$c - массив цитаты, ключи:
			text - текст цитаты
			date - дата
			name - имя цитирующего
	*/
	public static function PmQuote($c)
	{
		$lang=Eleanor::$Language[$GLOBALS['Eleanor']->module['config']['n']];
		return'<blockquote class="extend"><div class="top">'
		.$lang['quote']
		.($c['name'] || $c['date'] ? ' ('.$c['name'].' @ '.$c['date'].')' : '')
		.'</div><div class="text">'.$c['text'].'</div></blockquote>';
	}

	/*
		Страница просмотра диалога
		$dialog - массив диалога, ключи:
			id - id диалога
			owner - id владельца диалога
			lastview - дата последнего просмотра диалога
			tid - id темы
			lp_date - дата последнего поста
			caninvate - флаг возможности приглашать пользователей к диалогу
			canpermit - флаг возможности разрешения разрешать пользователям приглашать других пользователей к диалогу
			status - статус диалога
			invated - количество приглашенных пользователей
			title - название диалога
			hasattach - флаг наличия выложений в диалоге
			_opts - флаг отдельных опций для каждого получателя
		$posts - массив постов диалога, подробнее см. метод PmPosts.
		$attaches - массив вложений постов диалога, подробнее см. метод PmPosts.
		$authors - массив авторов постов диалога, подробнее см. метод PmPosts.
		$groups - массив групп авторов постов диалога, подробнее см. метод PmPosts.
		$cnt - количество постов всего
		$page - страница на которой мы сейчас находимся
		$pp - количество постов на страницу
		$last - номер последнего поста
		$links - массив ссылок, ключи:
			first_page - ссылка на первую страницу пагинатора
			pages - функция-генератор ссылок на остальные страницы
		$uploader - интерфейс загрузчика для добавления поста
		$captcha - капча добавления поста
		$invcaptcha - капча для приглашения пользователей к диалогу
	*/
	public static function ShowDialog($dialog,$posts,$attaches,$authors,$groups,$cnt,$page,$pp,$last,$links,$uploader,$captcha,$invcaptcha)
	{
		$lang=Eleanor::$Language[$GLOBALS['Eleanor']->module['config']['n']];
		if($dialog['caninvate']!==false)
		{
			$GLOBALS['jscripts'][]='addons/autocomplete/jquery.autocomplete.js';
			$GLOBALS['head'][__class__.__function__]='<link rel="stylesheet" type="text/css" href="addons/autocomplete/style.css" />';
		}

		$Lst=Eleanor::LoadListTemplate('table-form')
			->form(array('id'=>'pm-newpost','data-id'=>$dialog['id']))
			->begin()
			->head($lang['wanswer'])
			->item($lang['party'],'<span id="takepart">'.self::PmTakePart($authors).'</span>'
				.($dialog['caninvate']===false
					? ''
					: '<div><p class="small"><a href="#" onclick="$(\'#invate\').toggle();return false;">'.$lang['invateu'].'</a></p></div><div id="invate" style="display:none;padding-bottom:15px;"><div id="invated">'
						.self::PmInvate($dialog).'</div><div class="small"><a href="#" onclick="CORE.PM.ChangeRecepients(this,\'#invated\','.$dialog['id'].');return false;">'.($dialog['_opts'] ? $lang['hideo'] : $lang['showo']).'</a></div>'
						.($invcaptcha ? '<br /><label class="imp" for="captchainv" title="'.$lang['captcha_'].'">'.$lang['captcha'].'</label><div class="captcha" style="margin-bottom: .4em">'.$invcaptcha.'<br />'.Eleanor::Input('','',array('id'=>'captchainv')).'</div>' : '')
						.Eleanor::Button($lang['invateb'],'button',array('class'=>'btn_big','onclick'=>'CORE.PM.InvateUsers('.$dialog['id'].');')).'</div>'
				)
			)
			->item($lang['text'],$GLOBALS['Eleanor']->Editor->Area('text'));
		if($captcha)
			$Lst->item(array($lang['captcha'],Eleanor::Input('check','',array('tabindex'=>4)).'<br />'.$GLOBALS['Eleanor']->Captcha->GetCode(),'descr'=>$lang['captcha_']));

		return self::PmUserHeader(array('lp'=>$dialog['lp_date'],'n'=>$cnt,'lastpage'=>$cnt==$last,'noupdate'=>true))
			.'<div id="pm"><div class="heading2"><div class="binner" style="text-align:right"><h6>'.$dialog['title'].'</h6> <a href="#" class="dvdel" data-id="'.$dialog['id'].'" data-out="'.$GLOBALS['Eleanor']->Url->Prefix(true).'">'.$lang['del'].'</a> '.($dialog['status']&6 ? '' : '<a href="#" class="dvarch" data-id="'.$dialog['id'].'">'.$lang['archive'].'</a>')
			.'</div></div><div class="posts">'.self::PmPosts($dialog,$posts,$attaches,$authors,$groups).'</div><div class="status"></div>'
			.Eleanor::$Template->Pages($cnt,$pp,$page,array($links['pages'],$links['first_page']))
			.'<div style="text-align:center">'.Eleanor::Button($lang['loadnew'],'button',array('class'=>'pm-lnp','data-id'=>$dialog['id'])).'</div>'
			.$Lst->end()
			->submitline((string)$uploader)
			->submitline(Eleanor::Button($lang['answer']))
			->endform()
			.'</div>';
	}

	/*+Ajax
		$dialog - массив диалога, подробнее см. метод ShowDialog.
		$posts - массив постов, формат: id=>array(), ключи внутреннего массива:
			date - дата написания поста
			author - имя автора
			author_id - ID автора
			text - текст поста
			hasattach - флаг наличия вложений к посту
			_n - номер поста по порядку
			_canedit - флаг наличия возможности отредактировать данный пост
			_afind - ссылка на пост
			_aedit - ссылка нп полное редактирование поста
		$attaches - массив вложений, формат: id поста=>имя файла=>массив, ключи внутреннего массива:
			file - путь к файлу, относительно корня сайта
			size - размер файла
			preview - путь к превьюшке, если она есть. Если её нету - false
		$authors
			_party - наличие флага означает, что пользователь принимает участие в данном диалоге
			_online - флаг означающий что пользователь сейчас онлайн
			_group - ID основной группы пользователя
			full_name - полное имя пользователя
			name - имя пользователя (небезопасный HTML)
			register - дата регистрации
			location - местоположение
			signature - подпись
			avatar_location - путь к аватару
			avatar_type - тип аватара
		$groups
			title - название группы
			html_pref - HTML префикс группы
			html_end - HTML окончание группы
	*/
	public static function PmPosts($dialog,$posts,$attaches,$authors,$groups)
	{
		$lang=Eleanor::$Language[$GLOBALS['Eleanor']->module['config']['n']];
		list($w,$h)=explode(' ',Eleanor::$vars['avatar_size']);
		$text='';
		foreach($posts as $k=>&$v)
		{
			if(isset($authors[$v['author_id']]))
			{
				$a=$authors[$v['author_id']];
				if($a['avatar_location'])
				{
					switch($a['avatar_type'])
					{
						case'upload':
							$av=Eleanor::$uploads.'/avatars/';
						break;
						case'local':
							$av='images/avatars/';
						break;
						default:
							$av='';
					}

					$av='<img src="'.$av.$a['avatar_location'].'" style="'.($w ? 'max-width:'.$w.'px;' : '').($h ? 'max-height:'.$h.'px;' : '').'" alt="'.$a['full_name'].'" title="'.$a['full_name'].'" />';
				}
				else
					$av='<img src="images/avatars/guest.png" alt="'.$a['full_name'].'" title="'.$a['full_name'].'" />';
			}
			else
			{
				$a=false;
				$av='<img src="'.Eleanor::$vars['guest_avatar'].'" alt="'.$v['author'].'" title="'.$v['author'].'" />';
			}
			$ulc=$a ? Eleanor::$Login->UserLink($a['name'],$v['author_id']) : false;
			$gr=$a && isset($groups[$a['_group']]) ? $groups[$a['_group']] : false;

			$fi=isset($attaches[$k]) ? self::FilesImages($attaches[$k],$v['text']) : array(false,false);

			$text.='<table class="tabstyle post" id="post'.$k.'" style="margin:10px 0 10px">
			<tr>
				<th style="width:155px"><a name="p'.$k.'"></a><a href="#" class="pm-insert-nick">'.$v['author'].'</a>'.($a && $a['_online'] ? ' <span style="color:green">'.$lang['online'].'</span>' : '').'</th>
				<td>#'.$v['_n'].' <span class="small">'.$lang['from'].'</span> '.Eleanor::$Language->Date($v['date'],'fdt')
				.' <a rel="nofollow" href="'.$v['_afind'].'" class="small pm-ltp">'.$lang['link'].'</a>'
				.'</td>
			</tr>
			<tr><td style="vertical-align:top"><div style="text-align:center">'.$av.'</div>'
				.($a
					? '<a href="'.$ulc.'">'.$lang['profile'].'</a>'.($gr ? '<br />'.sprintf($lang['group'],$gr['html_pref'].$gr['_title'].$gr['html_end']) : '').'<br />'.sprintf($lang['register'],Eleanor::$Language->Date($a['register'],'fd')).'<br />'
					.($a && $a['location'] ? sprintf($lang['where'],$a['location']).'<br />' : '')
					: '')
				.'</td><td style="vertical-align:top"><div class="text">'.$v['text'].'</div>'
				.($fi[1] ? '<div class="images clr">'.$lang['aimages'].'<ul>'.$fi[1].'</ul></div>' : '')
				.($fi[0] ? '<div class="files clr">'.$lang['afiles'].'<ul>'.$fi[0].'</ul></div>' : '')
				.($a && $a['signature'] ? '<div class="small signature">----<br />'.$a['signature'].'</div>' : '')
				.'</td></tr>
			<tr class="buttons"><td colspan="2" style="text-align:right">'.($v['_canedit'] ? '<span class="pm-edit" data-el="'.($v['_canedit']===true ? 0 : $v['_canedit']).'"><a href="#" data-id="'.$k.'" class="pm-quick-edit">'.$lang['qedit'].'</a> | <a href="'.$v['_aedit'].'">'.$lang['edit'].'</a> | </span>' : '').'<a href="#" class="pm-quick-quote" data-id="'.$k.'" data-date="'.$v['date'].'" data-name="'.$v['author'].'">'.$lang['qquote'].'</a></td></tr>
		</table>';
		}
		return$text;
	}

	/*Ajax
		Интерфейс поля получателей инвайта при ответе
		$dialog - массив диалога, ключи:
			canpermit - флаг возможности включения разрешения приглашать пользователей к диалогу
			caninvate - флаг возможности приглашать пользователей к диалогу
		$values - массив значений
			_opts - флаг отдельных опций для каждого получателя
			_to - строка либо массив (при включенном _opts) имен пользователей, кому направляются диалоги
	*/
	public static function PmInvate($dialog,$values=array())
	{
		$lang=Eleanor::$Language[$GLOBALS['Eleanor']->module['config']['n']];
		if($dialog['_opts'])
		{
			$r='<ul class="pmadduser" id="pmptoul">';
			if(empty($values['_to']))
				$values['_to']=array('');

			foreach($values['_to'] as $id=>&$v)
				$r.='<li>'.Eleanor::Input('_to['.$id.']',$v,array('placeholder'=>$lang['*whom'],'tabindex'=>1,'style'=>'width: 300px;','size'=>30,'maxlength'=>60,'class'=>'namehere')).' '
					.($dialog['canpermit']
						?
						Eleanor::Input('caninvate['.$id.']',0,array('type'=>'hidden'))
						.Eleanor::Input('canpermit['.$id.']',0,array('type'=>'hidden'))

						.Eleanor::Check('caninvate['.$id.']',isset($values['caninvate'][$id]),array('title'=>$lang['allowinvate'])).' '
						.Eleanor::Check('canpermit['.$id.']',isset($values['canpermit'][$id]),array('title'=>$lang['allowuinvate'])).'<a href="#" title="'.$lang['del'].'" class="minus">&minus;</a> <a class="plus" href="#" title="'.$lang['add'].'">+</a> </li>'
						: ''
					);

			return$r.'</ul><script type="text/javascript">/*<![CDATA[*/$(function(){CORE.PM.ComplexRecepients("#pmptoul","'.$dialog['caninvate'].'");});//]]></script>';
		}
		$values+=array(
			'_to'=>'',
			'caninvate'=>'',
			'canpermit'=>'',
		);
		return Eleanor::Input('_to',$values['_to'],array('placeholder'=>$lang['*whom'],'tabindex'=>1,'style'=>'width: 300px;','title'=>$lang['numinv']($dialog['caninvate']),'size'=>30,'maxlength'=>60,'id'=>'pmptof'))
			.($dialog['canpermit'] ? ' '.Eleanor::Check('caninvate',$values['caninvate'],array('title'=>$lang['allowinvate'])).' '.Eleanor::Check('canpermit',$values['canpermit'],array('title'=>$lang['allowuinvate'])) : '')
			.'<script type="text/javascript">/*<![CDATA[*/$(function(){CORE.PM.SimpleRecepients("#pmptof","'.$dialog['caninvate'].'");});//]]></script>';
	}

	/*Ajax
		Интерфейс поля получателей при создании диалога
		$values - массив значений
			_opts - флаг отдельных опций для каждого получателя
			_to - строка либо массив (при включенном _opts) имен пользователей, кому направляются диалоги
	*/
	public static function PmRecepient($values)
	{
		$lang=Eleanor::$Language[$GLOBALS['Eleanor']->module['config']['n']];
		if($values['_opts'])
		{
			$r='<ul class="reset" id="pmtoul">';
			if(!$values['_to'])
				$values['_to']=array('');

			foreach($values['_to'] as $id=>&$v)
				$r.='<li>'.Eleanor::Input('_to['.$id.']',$v,array('placeholder'=>$lang['*towho'],'tabindex'=>1,'style'=>'width: 300px;','size'=>30,'maxlength'=>60,'class'=>'namehere')).' '
					.Eleanor::Input('caninvate['.$id.']',0,array('type'=>'hidden'))
					.Eleanor::Input('canpermit['.$id.']',0,array('type'=>'hidden'))

					.Eleanor::Check('caninvate['.$id.']',isset($values['caninvate'][$id]),array('title'=>$lang['allowinvate'])).' '
					.Eleanor::Check('canpermit['.$id.']',isset($values['canpermit'][$id]),array('title'=>$lang['allowuinvate'])).'<a href="#" title="'.$lang['del'].'" class="minus">&minus;</a> <a class="plus" href="#" title="'.$lang['add'].'">+</a> </li>';

			return$r.'</ul><script type="text/javascript">/*<![CDATA[*/$(function(){CORE.PM.ComplexRecepients("#pmtoul","'.$GLOBALS['Eleanor']->module['maxinvates'].'");});//]]></script>';
		}
		return Eleanor::Input('_to',$values['_to'],array('placeholder'=>$lang['*towho'],'tabindex'=>1,'style'=>'width: 300px;','title'=>$lang['numinv']($GLOBALS['Eleanor']->module['maxinvates']),'size'=>30,'maxlength'=>60,'id'=>'pmtof'))
			.' '.Eleanor::Check('caninvate',$values['caninvate'],array('title'=>$lang['allowinvate'])).' '.Eleanor::Check('canpermit',$values['canpermit'],array('title'=>$lang['allowuinvate']))
			.'<script type="text/javascript">/*<![CDATA[*/$(function(){CORE.PM.SimpleRecepients("#pmtof","'.$GLOBALS['Eleanor']->module['maxinvates'].'");});//]]></script>';
	}

	/*Ajax
		Интерфейс элемента шаблона: список пользователей, принимающих участие в диалоге
		$authors - массив авторов постов диалога, подробнее см. метод PmPosts.
	*/
	public static function PmTakePart($authors)
	{
		$party='';
		foreach($authors as $k=>&$v)
			if(isset($v['_party']))
				$party.='<a href="'.Eleanor::$Login->UserLink($v['name'],$k).'">'.htmlspecialchars($v['name'],ELENT,CHARSET).'</a>, ';
		return rtrim($party,', ');
	}

	/*Ajax
		Элемент шаблона: интерфейс быстрого редактирования поста
		$id - ID поста, который правится
		$values - массив значения, ключи:
			text - текст поста
		$links - массив ссылок, ключи:
			form - ссылка для action формы
	*/
	public static function PostEdit($id,$values,$links)
	{
		$lang=Eleanor::$Language[$GLOBALS['Eleanor']->module['config']['n']];
		return'<form method="post" action="'.$links['form'].'">'.$GLOBALS['Eleanor']->Editor->Area('text'.$id,$values['text']).'<div style="text-align:center">'.Eleanor::Button($lang['save']).' '.Eleanor::Button($lang['cancel'],'button',array('class'=>'pm-cancel')).' '.Eleanor::Button($lang['tofull'],'submit',array('class'=>'pm-to-full','name'=>'_tofull')).'</div></form>';
	}

	/*Ajax
		Элемент шаблона: возвращение массива для применения его через AJAX после сохранения поста после быстрого редактирования
		$text - текст поста
		$attaches - массив вложений постов диалога, подробнее см. метод PmPosts.
	*/
	public static function AfterAjaxEdit($text,$attaches)
	{
		$lang=Eleanor::$Language[$GLOBALS['Eleanor']->module['config']['n']];
		$fi=self::FilesImages($attaches,$text);
		return array(
			'text'=>'<div class="text">'.$text.'</div>',
			'images'=>$fi[1] ? '<div class="images clr">'.$lang['aimages'].'<ul>'.$fi[1].'</ul></div>' : '',
			'files'=>$fi[0] ? '<div class="files clr">'.$lang['afiles'].'<ul>'.$fi[0].'</ul></div>' : '',
		);
	}

	public static function FilesImages(array$attaches,$text)
	{
		$atts=$attsi='';
		foreach($attaches as $k=>&$atv)
		{
			if(strpos($text,$atv['file'])!==false)
				continue;
			if(preg_match('#\.(jpe?g|bmp|gif|png)$#',$atv['file'])>0)
			{
				$attsi.='<li><a href="'.$atv['file'].'" target="_blank" class="gallery" title="'.$k.'"><img src="'.($atv['preview'] ? $atv['preview'] : $atv['file']).'" /></a><br /><span>'.Files::BytesToSize($atv['size']).'</span></li>';
				if(!isset($GLOBALS['head']['colorbox']))
				{
					$GLOBALS['jscripts'][]='addons/colorbox/jquery.colorbox-min.js';
					$GLOBALS['head']['colorbox']='<link rel="stylesheet" media="screen" href="addons/colorbox/colorbox.css" />';
					$GLOBALS['head'][]='<script type="text/javascript">//<![CDATA[
$(function(){
	var F=function(){
		$("a.gallery").colorbox({
			title: function(){
				var url=$(this).attr("href"),
					title=$(this).find("img").attr("title");
				return "<a href=\""+url+"\" target=\"_blank\">"+(title ? title : url)+"</a>";
			},
			rel:"gallery",
			maxWidth:Math.round(screen.width/1.5),
			maxHeight:Math.round(screen.height/1.5),
		});
	}
	if(CORE.in_ajax.length)
		CORE.after_ajax.push(F);
	else
		F();
});//]]></script>';
				}
			}
			else
				$atts.='<li><a href="'.$atv['file'].'" target="_blank">'.$k.'</a><span> '.Files::BytesToSize($atv['size']).'</span></li>';
		}
		return array($atts,$attsi);
	}
}