<?php
/*
	Copyright  Eleanor CMS
	URL: http://eleanor-cms.ru, http://eleanor-cms.com
	E-mail: support@eleanor-cms.ru
	Developing: Alexander Sunvas*
	Interface: Rumin Sergey
	=====
	*Pseudonym
*/

class PmBBQoute extends OwnBbCode
{
	public static function PreDisplay($t,$p,$c,$cu)
	{
		$p=$p ? Strings::ParseParams($p) : array();
		if(isset($p['noparse']))
		{
			unset($p['noparse']);
			return parent::PreSave($t,$p,$c,true);
		}
		if(!$cu)
			return self::RestrictDisplay($t,$p,$c);
		return Eleanor::$Template->PmQuote(array(
			'date'=>isset($p['date']) ? Eleanor::$Language->Date($p['date'],'fdt') : false,
			'name'=>isset($p['name']) ? $p['name'] : false,
			'p'=>isset($p['p']) ? (int)$p['p'] : false,
			'd'=>isset($p['d']) ? (int)$p['d'] : false,
			'text'=>$c,
		));
	}

	public static function PreEdit($t,$p,$c,$cu)
	{
		return parent::PreEdit($t,$p,"\r\n".$c."\r\n",$cu);
	}

	public static function PreSave($t,$p,$c,$cu)
	{
		$c=preg_replace("#^(\r?\n?<br />\r?\n?)+#i",'',$c);
		$c=preg_replace("#(\r?\n?<br />\r?\n?)+$#i",'',$c);
		return parent::PreSave($t,$p,$c,$cu);
	}
}